import { createReducer, on } from '@ngrx/store';
import { initialState } from './state';
import { infoSuccess, appendInfoList, info, infoFailure } from './actions';
import * as AuthenticationStore from '@app/store/account/authentication';

export const reducer = createReducer(
  initialState,
  on(info, (state, action) => {
    return {
      ...state,
      infoListProcessing: true
    };
  }),

  on(infoSuccess, (state, action) => {
    return {
      ...state,
      infoList: action.infoList,
      infoStatus: action.res,
      infoListProcessing: false
    };
  }),

  on(infoFailure, (state, action) => {
    return {
      ...state,
      infoListProcessing: false
    };
  }),

  on(appendInfoList, (state, action) => {
    return {
      ...state,
      infoList: [...state.infoList, action.info]
    };
  }),

  on(AuthenticationStore.logout, (state, action) => {
    return {
      ...initialState
    };
  })
);
